-------------------------------------------------------------- 
--  Subject : Symbolic differentiation ( main program )
--  Copyright (c) 1999 by A.Baranovsky
--------------------------------------------------------------

uses global, lukas

function Swap( var U, var V ) 
  temp << U 
  U << V    
  V << temp
return 0

function InOrder( A )            
  if ClassOf( A ) = ClassArray then  
    L == A[ 2 ] 
      
    if   Card( A ) = 2 then  

      oper := A[1]
      if A[1] = UN then 
        oper := MINUS
      end

      if ClassOf( L ) = ClassArray then 
        RR := InOrder( L )
      else
        RR := STR( L )
      end 

      if ( oper = LOG ) and ( Substr( RR, 1, 1 ) <> '(' ) then  
        S :=  oper + '(' + RR + ')'
      else
        S := '(' + oper + RR + ')'
      end

    elsif Card( A ) = 3 then

      oper := A[1] 

      R == A[ 3 ]  
      if    ( ClassOf( L ) = ClassArray ) and ( ClassOf( R ) = ClassArray ) then
        LL := InOrder( L )
        RR := InOrder( R )
      elsif ( ClassOf( L ) = ClassArray ) and ( ClassOf( R ) <> ClassArray ) then 
        LL := InOrder( L )
        RR := STR( R ) 
      elsif ( ClassOf( L ) <> ClassArray ) and ( ClassOf( R ) = ClassArray ) then 
        LL := STR( L )
        RR := InOrder( R )
      else 
        LL := STR( L )
        RR := STR( R )
      end

      if Substr( RR, 1, 1 ) = MINUS then
        if    oper = PLUS then
          oper := ''
        end
      end

      S := '(' + LL + oper + RR + ')'
    end
  else
    S := STR( A )
  end
return S

function TR( I )
  writeln( 'trace ' + STR(I) )
return 0

function Comp( var R )
  K  := Card( R ) 
  Oper := R[ 1 ]  
  if    K = 2 then
    if Oper = UN then 
      X1 == R[ 2 ]
      if ClassOf( X1 ) = ClassArray then
        Comp( X1 )      
      end
      if IsConstant( X1 ) then
        Swap( -X1, R )
      end
    end 
  elsif K = 3 then
    X1 == R[ 2 ]
    X2 == R[ 3 ]

    if ClassOf( X1 ) = ClassArray then
      Comp( X1 )      
    end
    if ClassOf( X2 ) = ClassArray then
      Comp( X2 )
    end

    Ground := IsConstant( X1 ) and IsConstant( X2 )

    if Oper = PLUS then 
      if Ground  then
        Swap( X1 + X2, R )
      elsif IsZero( X1 ) then
        Swap( X2, R )
      elsif IsZero( X2 ) then
        Swap( X1, R ) 
      elsif Equal( X1, X2 ) then 
        Swap( [ MULT, 2, X1 ], R ) 
      elsif IsNeg( X1 ) and ( not IsNeg( X2 ) ) then             
        Swap( [ MINUS, X2, X1[ 2 ] ], R )
      elsif IsNeg( X2 ) and ( not IsNeg( X1 ) ) then              
        Swap( [ MINUS, X1, X2[ 2 ] ], R ) 
      elsif IsMult( X1 ) and IsMult( X2 ) then
        if    Equal( X1[ 2 ], X2[ 2 ] ) then
          Swap( [ MULT, X1[ 2 ], [ PLUS, X1[ 3 ], X2[ 3 ] ] ], R ) 
        elsif Equal( X1[ 3 ], X2[ 3 ] ) then 
          Swap( [ MULT, X1[ 3 ], [ PLUS, X1[ 2 ], X2[ 2 ] ] ], R ) 
        end
      elsif IsMult( X1 ) then
        if    Equal( X1[ 2 ], X2 ) then
           Swap( [ MULT, X2, [ PLUS, X1[ 3 ], 1 ] ], R )
        elsif Equal( X1[ 3 ], X2 ) then
           Swap( [ MULT, X2, [ PLUS, X1[ 2 ], 1 ] ], R ) 
        end
      elsif IsMult( X2 ) then 
        if    Equal( X2[ 2 ], X1 ) then
           Swap( [ MULT, X1, [ PLUS, X2[ 3 ], 1 ] ], R )
        elsif Equal( X2[ 3 ], X1 ) then
           Swap( [ MULT, X1, [ PLUS, X2[ 2 ], 1 ] ], R ) 
        end
      elsif IsAdd( X1 ) and IsConstant( X2 ) then  
        if     IsConstant( X1[ 2 ] ) then
           Swap( [ PLUS, X1[ 3 ], X1[ 2 ] + X2 ], R ) 
        elsif  IsConstant( X1[ 3 ] ) then
           Swap( [ PLUS, X1[ 2 ], X1[ 3 ] + X2 ], R )  
        end
      elsif IsAdd( X2 ) and IsConstant( X1 ) then   
        if     IsConstant( X2[ 2 ] ) then
           Swap( [ PLUS, X2[ 3 ], X2[ 2 ] + X1 ], R ) 
        elsif  IsConstant( X2[ 3 ] ) then
           Swap( [ PLUS, X2[ 2 ], X2[ 3 ] + X1 ], R )  
        end
      elsif IsSub( X1 ) and IsConstant( X2 ) then   
        if     IsConstant( X1[ 2 ] ) then
           Swap( [ MINUS, X1[ 2 ] + X2, X1[ 3 ] ], R )     
        elsif  IsConstant( X1[ 3 ] ) then
           Swap( [ PLUS,  X2 - X1[ 3 ], X1[ 2 ] ], R )  
        end
      elsif IsSub( X2 ) and IsConstant( X1 ) then    
        if     IsConstant( X2[ 2 ] ) then
           Swap( [ MINUS, X1 + X2[ 2 ], X2[ 3 ] ], R )
        elsif  IsConstant( X2[ 3 ] ) then
           Swap( [ PLUS, X1 - X2[ 3 ], X2[ 2 ] ], R )                                
        end
      end
    elsif Oper = MINUS then  
      if Ground  then
        Swap( X1 - X2, R )
      elsif IsZero( X1 ) then
        Swap( [ UN, X2 ], R )
      elsif IsZero( X2 ) then
        Swap( X1, R ) 
      elsif Equal( X1, X2 ) then
        Destroy( R )
        R := 0  
      elsif IsNeg( X1 ) and ( not IsNeg( X2 ) ) then              
        Swap( [ PLUS, X1[ 2 ], X2 ], R )
      elsif IsNeg( X2 ) and ( not IsNeg( X1 ) ) then              
        Swap( [ PLUS, X1, X2[ 2 ] ], R ) 
      elsif IsMult( X1 ) and IsMult( X2 ) then 
        if    Equal( X1[ 2 ], X2[ 2 ] ) then
          Swap( [ MULT, X1[ 2 ], [ MINUS, X1[ 3 ], X2[ 3 ] ] ], R ) 
        elsif Equal( X1[ 3 ], X2[ 3 ] ) then 
          Swap( [ MULT, X1[ 3 ], [ MINUS, X1[ 2 ], X2[ 2 ] ] ], R ) 
        end
      elsif IsMult( X1 ) then
        if    Equal( X1[ 2 ], X2 ) then
           Swap( [ MULT, X2, [ MINUS, X1[ 3 ], 1 ] ], R )
        elsif Equal( X1[ 3 ], X2 ) then
           Swap( [ MULT, X2, [ MINUS, X1[ 2 ], 1 ] ], R ) 
        end
      elsif IsMult( X2 ) then 
        if    Equal( X2[ 2 ], X1 ) then
           Swap( [ MULT, X1, [ MINUS, X2[ 3 ], 1 ] ], R )
        elsif Equal( X2[ 3 ], X1 ) then
           Swap( [ MULT, X1, [ MINUS, X2[ 2 ], 1 ] ], R ) 
        end
      elsif IsAdd( X1 ) and IsConstant( X2 ) then   
        if     IsConstant( X1[ 2 ] ) then
           Swap( [ PLUS, X1[ 3 ], X1[ 2 ] - X2 ], R ) 
        elsif  IsConstant( X1[ 3 ] ) then
           Swap( [ PLUS, X1[ 2 ], X1[ 3 ] - X2 ], R )  
        end
      elsif IsAdd( X2 ) and IsConstant( X1 ) then   
        if     IsConstant( X2[ 2 ] ) then
           Swap( [ PLUS, X2[ 3 ], X1 - X2[ 2 ] ], R ) 
        elsif  IsConstant( X2[ 3 ] ) then
           Swap( [ PLUS, X2[ 2 ], X1 - X2[ 3 ] ], R )  
        end
      elsif IsSub( X1 ) and IsConstant( X2 ) then    
        if     IsConstant( X1[ 2 ] ) then
           Swap( [ MINUS, X1[ 2 ] - X2, X1[ 3 ] ], R )     
        elsif  IsConstant( X1[ 3 ] ) then
           Swap( [ MINUS, X1[ 2 ], X2 + X1[ 3 ] ], R )  
        end
      elsif IsSub( X2 ) and IsConstant( X1 ) then    
        if     IsConstant( X2[ 2 ] ) then
           Swap( [ PLUS, X1 - X2[ 2 ], X2[ 3 ] ], R )
        elsif  IsConstant( X2[ 3 ] ) then
           Swap( [ MINUS, X1 - X2[ 3 ], X2[ 2 ] ], R )                                
        end
      end
    elsif Oper = MULT then 
      if Ground  then
        Swap( X1 * X2, R )
      elsif IsZero( X1 ) then
        Swap( X1, R )
      elsif IsZero( X2 ) then
        Swap( X2, R )
      elsif IsNeg( X1 ) then
        Swap( [ MULT, -1, [ MULT, X1[ 2 ], X2 ] ], R )
      elsif IsNeg( X2 ) then 
        Swap( [ MULT, -1, [ MULT, X2[ 2 ], X1 ] ], R )
      elsif IsUnit( X1 ) then
        Swap( X2, R )
      elsif IsUnit( X2 ) then
        Swap( X1, R )
      elsif Equal( X1, X2 ) then 
        Swap( [ POW, X1, 2 ], R )
      elsif IsPow( X1 ) and IsPow( X2 ) and Equal( X1[ 2 ], X2[ 2 ] ) then
        Swap( [ POW, X1[ 2 ], [ PLUS, X1[ 3 ], X2[ 3 ] ] ], R )
      elsif IsPow( X1 ) and Equal( X1[ 2 ], X2 ) then
        Swap( [ POW, X1[ 2 ], [ PLUS, X1[ 3 ], 1 ] ], R ) 
      elsif IsPow( X2 ) and Equal( X2[ 2 ], X1 ) then 
        Swap( [ POW, X2[ 2 ], [ PLUS, X2[ 3 ], 1 ] ], R ) 
      elsif IsMult( X1 ) and IsPow( X2 ) then
        u == X2[ 2 ]                            -- ( A*U ) * ( U in pow V )
        v == X2[ 3 ]
        if    Equal( X1[ 2 ], u ) then
          Swap( [ MULT, X1[ 3 ], [ POW, u, [ PLUS, v, 1 ] ] ], R )      
        elsif Equal( X1[ 3 ], u ) then
          Swap( [ MULT, X1[ 2 ], [ POW, u, [ PLUS, v, 1 ] ] ], R )      
        elsif IsPow( X1[ 2 ] ) and Equal( X1[ 2 ][ 2 ], u ) then 
  
          -- A == X1[ 3 ]
          -- U == X1[ 2, 2 ]
          -- C == X1[ 2, 3 ]
          -- ( U ^ C )*A  *  ( U ^ V ) = A * ( U ^ ( C + V ) )
  
          Swap( [ MULT, X1[ 3 ], [ POW, u, [ PLUS, v, X1[ 2 ][ 3 ] ] ] ], R )   
        elsif IsPow( X1[ 3 ] ) and Equal( X1[ 3 ][ 2 ], u ) then  
  
          -- A == X1[ 2 ]
          -- U == X1[ 3, 2 ] 
          -- C == X1[ 3, 3 ] 
          -- A*( U ^ C )  *  ( U ^ V ) = A * ( U ^ ( C + V ) ) 
  
          Swap( [ MULT, X1[ 2 ], [ POW, u, [ PLUS, v, X1[ 3 ][ 3 ] ] ] ], R )   
        end
      elsif IsMult( X2 ) and IsPow( X1 ) then 
        u == X1[ 2 ]                           -- symmetry 
        v == X1[ 3 ]
        if    Equal( X2[ 2 ], u ) then
          Swap( [ MULT, X2[ 3 ], [ POW, u, [ PLUS, v, 1 ] ] ], R )      
        elsif Equal( X2[ 3 ], u ) then
          Swap( [ MULT, X2[ 2 ], [ POW, u, [ PLUS, v, 1 ] ] ], R )      
        elsif IsPow( X2[ 2 ] ) and Equal( X2[ 2 ][ 2 ], u ) then  
  
          -- A == X2[ 3 ]
          -- U == X2[ 2, 2 ]
          -- C == X2[ 2, 3 ]
          -- ( U ^ C )*A  *  ( U ^ V ) = A * ( U ^ ( C + V ) )
  
          Swap( [ MULT, X2[ 3 ], [ POW, u, [ PLUS, v, X2[ 2 ][ 3 ] ] ] ], R )   
        elsif IsPow( X2[ 3 ] ) and Equal( X2[ 3 ][ 2 ], u ) then  
  
          -- A == X2[ 2 ]
          -- U == X2[ 3, 2 ] 
          -- C == X2[ 3, 3 ] 
          -- A*( U ^ C )  *  ( U ^ V ) = A * ( U ^ ( C + V ) ) 
  
          Swap( [ MULT, X2[ 2 ], [ POW, u, [ PLUS, v, X2[ 3 ][ 3 ] ] ] ], R )   
        end
      elsif IsMult( X1 ) then
        if    Equal( X1[ 2 ], X2 ) then
          Swap( [ MULT, X1[ 3 ], [ POW, X2, 2 ] ], R )
        elsif Equal( X1[ 3 ], X2 ) then
          Swap( [ MULT, X1[ 2 ], [ POW, X2, 2 ] ], R ) 
        elsif IsPow( X1[ 2 ] ) and Equal( X1[ 2, 2 ], X2 ) then
          Swap( [ MULT, X1[ 3 ], [ POW, X2, [ PLUS, X1[ 2, 3 ], 1 ] ] ], R )               
        elsif IsPow( X1[ 3 ] ) and Equal( X1[ 3, 2 ], X2 ) then 
          Swap( [ MULT, X1[ 2 ], [ POW, X2, [ PLUS, X1[ 3, 3 ], 1 ] ] ], R )               
        end  
      elsif IsMult( X2 ) then 
        if    Equal( X2[ 2 ], X1 ) then
          Swap( [ MULT, X2[ 3 ], [ POW, X1, 2 ] ], R )
        elsif Equal( X2[ 3 ], X1 ) then
          Swap( [ MULT, X2[ 2 ], [ POW, X1, 2 ] ], R ) 
        elsif IsPow( X2[ 2 ] ) and Equal( X2[ 2, 2 ], X1 ) then 
          Swap( [ MULT, X2[ 3 ], [ POW, X1, [ PLUS, X2[ 2, 3 ], 1 ] ] ], R )               
        elsif IsPow( X2[ 3 ] ) and Equal( X2[ 3, 2 ], X1 ) then 
          Swap( [ MULT, X2[ 2 ], [ POW, X1, [ PLUS, X2[ 3, 3 ], 1 ] ] ], R )               
        end  
      end
    elsif Oper = DIV then 
      if IsUnit( X2 ) then
        Swap( X1, R )
      elsif IsZero( X1 ) then
        Swap( X1, R )
      elsif IsPow( X2 ) then  
        Swap( [ MULT, X1, [ POW, X2[ 2 ], [ UN, X2[ 3 ] ] ] ], R )  
      elsif IsZero( X2 ) then
        raise EDivByZero()           
      else
        Swap( [ MULT, X1, [ POW, X2, -1 ] ], R )
      end
    elsif Oper = POW then
      if    IsUnit( X2 ) then
        Swap( X1, R )
      elsif IsZero( X2 ) then
        Destroy( R )
        R := 1
      end 
    end 
  end
return 0

function Compress( A )   
  Ground := TRUE
  N := Card( A )
  R := array( N )

  R[ 1 ] := A[ 1 ]

  for I:=2 to N do
    AI == A[ I ]
    RI == R[ I ]
    if    ClassOf( AI ) = ClassArray then
      RI := Compress( AI )
      if ( ClassOf( RI ) = ClassArray ) or IsVar( RI ) then
        Ground := FALSE
      end 
    elsif IsVar( AI ) then 
      Ground := FALSE
      RI := AI
    else
      RI := AI
    end
  end

  Oper := R[ 1 ]

  if Oper = UN then
    Oper := Oper
  end


  if Oper = PLUS then
    X1 == R[ 2 ]
    X2 == R[ 3 ]
    if Ground  then
      Swap( X1 + X2, R )
    elsif IsZero( X1 ) then
      Swap( X2, R )
    elsif IsZero( X2 ) then
      Swap( X1, R ) 
    elsif Equal( X1, X2 ) then 
      Swap( [ MULT, 2, X1 ], R ) 
    elsif IsNeg( X1 ) and ( not IsNeg( X2 ) ) then             
      Swap( [ MINUS, X2, X1[ 2 ] ], R )
    elsif IsNeg( X2 ) and ( not IsNeg( X1 ) ) then              
      Swap( [ MINUS, X1, X2[ 2 ] ], R ) 
    elsif IsMult( X1 ) and IsMult( X2 ) then
      if    Equal( X1[ 2 ], X2[ 2 ] ) then
        Swap( [ MULT, X1[ 2 ], [ PLUS, X1[ 3 ], X2[ 3 ] ] ], R ) 
      elsif Equal( X1[ 3 ], X2[ 3 ] ) then 
        Swap( [ MULT, X1[ 3 ], [ PLUS, X1[ 2 ], X2[ 2 ] ] ], R ) 
      end
    elsif IsMult( X1 ) then
      if    Equal( X1[ 2 ], X2 ) then
         Swap( [ MULT, X2, [ PLUS, X1[ 3 ], 1 ] ], R )
      elsif Equal( X1[ 3 ], X2 ) then
         Swap( [ MULT, X2, [ PLUS, X1[ 2 ], 1 ] ], R ) 
      end
    elsif IsMult( X2 ) then 
      if    Equal( X2[ 2 ], X1 ) then
         Swap( [ MULT, X1, [ PLUS, X2[ 3 ], 1 ] ], R )
      elsif Equal( X2[ 3 ], X1 ) then
         Swap( [ MULT, X1, [ PLUS, X2[ 2 ], 1 ] ], R ) 
      end
    end
  elsif Oper = MINUS then 
    X1 == R[ 2 ]
    X2 == R[ 3 ]
    if Ground  then
      Swap( X1 - X2, R )
    elsif IsZero( X1 ) then
      Swap( [ UN, X2 ], R )
    elsif IsZero( X2 ) then
      Swap( X1, R ) 
    elsif Equal( X1, X2 ) then
      Destroy( R )
      R := 0  
    elsif IsNeg( X1 ) and ( not IsNeg( X2 ) ) then              
      Swap( [ PLUS, X1[ 2 ], X2 ], R )
    elsif IsNeg( X2 ) and ( not IsNeg( X1 ) ) then              
      Swap( [ PLUS, X1, X2[ 2 ] ], R ) 
    elsif IsMult( X1 ) and IsMult( X2 ) then 
      if    Equal( X1[ 2 ], X2[ 2 ] ) then
        Swap( [ MULT, X1[ 2 ], [ MINUS, X1[ 3 ], X2[ 3 ] ] ], R ) 
      elsif Equal( X1[ 3 ], X2[ 3 ] ) then 
        Swap( [ MULT, X1[ 3 ], [ MINUS, X1[ 2 ], X2[ 2 ] ] ], R ) 
      end
    elsif IsMult( X1 ) then
      if    Equal( X1[ 2 ], X2 ) then
         Swap( [ MULT, X2, [ MINUS, X1[ 3 ], 1 ] ], R )
      elsif Equal( X1[ 3 ], X2 ) then
         Swap( [ MULT, X2, [ MINUS, X1[ 2 ], 1 ] ], R ) 
      end
    elsif IsMult( X2 ) then 
      if    Equal( X2[ 2 ], X1 ) then
         Swap( [ MULT, X1, [ MINUS, X2[ 3 ], 1 ] ], R )
      elsif Equal( X2[ 3 ], X1 ) then
         Swap( [ MULT, X1, [ MINUS, X2[ 2 ], 1 ] ], R ) 
      end
    end
  elsif Oper = UN then
    X1 == R[ 2 ] 
    if Ground then
      Swap( -X1, R )
    end
  elsif Oper = MULT then
    X1 == R[ 2 ] 
    X2 == R[ 3 ]
    if Ground  then
      Swap( X1 * X2, R )
    elsif IsZero( X1 ) then
      Swap( X1, R )
    elsif IsZero( X2 ) then
      Swap( X2, R )
    elsif IsNeg( X1 ) then
      Swap( [ MULT, -1, [ MULT, X1[ 2 ], X2 ] ], R )
    elsif IsNeg( X2 ) then 
      Swap( [ MULT, -1, [ MULT, X2[ 2 ], X1 ] ], R )
    elsif IsUnit( X1 ) then
      Swap( X2, R )
    elsif IsUnit( X2 ) then
      Swap( X1, R )
    elsif Equal( X1, X2 ) then 
      Swap( [ POW, X1, 2 ], R )
    elsif IsPow( X1 ) and IsPow( X2 ) and Equal( X1[ 2 ], X2[ 2 ] ) then
      Swap( [ POW, X1[ 2 ], [ PLUS, X1[ 3 ], X2[ 3 ] ] ], R )
    elsif IsPow( X1 ) and Equal( X1[ 2 ], X2 ) then
      Swap( [ POW, X1[ 2 ], [ PLUS, X1[ 3 ], 1 ] ], R ) 
    elsif IsPow( X2 ) and Equal( X2[ 2 ], X1 ) then 
      Swap( [ POW, X2[ 2 ], [ PLUS, X2[ 3 ], 1 ] ], R ) 
    elsif IsMult( X1 ) and IsPow( X2 ) then
      u == X2[ 2 ]                            -- ( A*U ) * ( U in pow V )
      v == X2[ 3 ]
      if    Equal( X1[ 2 ], u ) then
        Swap( [ MULT, X1[ 3 ], [ POW, u, [ PLUS, v, 1 ] ] ], R )      
      elsif Equal( X1[ 3 ], u ) then
        Swap( [ MULT, X1[ 2 ], [ POW, u, [ PLUS, v, 1 ] ] ], R )      
      elsif IsPow( X1[ 2 ] ) and Equal( X1[ 2 ][ 2 ], u ) then 

        -- A == X1[ 3 ]
        -- U == X1[ 2, 2 ]
        -- C == X1[ 2, 3 ]
        -- ( U ^ C )*A  *  ( U ^ V ) = A * ( U ^ ( C + V ) )

        Swap( [ MULT, X1[ 3 ], [ POW, u, [ PLUS, v, X1[ 2 ][ 3 ] ] ] ], R )   
      elsif IsPow( X1[ 3 ] ) and Equal( X1[ 3 ][ 2 ], u ) then  

        -- A == X1[ 2 ]
        -- U == X1[ 3, 2 ] 
        -- C == X1[ 3, 3 ] 
        -- A*( U ^ C )  *  ( U ^ V ) = A * ( U ^ ( C + V ) ) 

        Swap( [ MULT, X1[ 2 ], [ POW, u, [ PLUS, v, X1[ 3 ][ 3 ] ] ] ], R )   
      end
    elsif IsMult( X2 ) and IsPow( X1 ) then 
      u == X1[ 2 ]                           -- symmetry 
      v == X1[ 3 ]
      if    Equal( X2[ 2 ], u ) then
        Swap( [ MULT, X2[ 3 ], [ POW, u, [ PLUS, v, 1 ] ] ], R )      
      elsif Equal( X2[ 3 ], u ) then
        Swap( [ MULT, X2[ 2 ], [ POW, u, [ PLUS, v, 1 ] ] ], R )      
      elsif IsPow( X2[ 2 ] ) and Equal( X2[ 2 ][ 2 ], u ) then  

        -- A == X2[ 3 ]
        -- U == X2[ 2, 2 ]
        -- C == X2[ 2, 3 ]
        -- ( U ^ C )*A  *  ( U ^ V ) = A * ( U ^ ( C + V ) )

        Swap( [ MULT, X2[ 3 ], [ POW, u, [ PLUS, v, X2[ 2 ][ 3 ] ] ] ], R )   
      elsif IsPow( X2[ 3 ] ) and Equal( X2[ 3 ][ 2 ], u ) then  

        -- A == X2[ 2 ]
        -- U == X2[ 3, 2 ] 
        -- C == X2[ 3, 3 ] 
        -- A*( U ^ C )  *  ( U ^ V ) = A * ( U ^ ( C + V ) ) 

        Swap( [ MULT, X2[ 2 ], [ POW, u, [ PLUS, v, X2[ 3 ][ 3 ] ] ] ], R )   
      end
    elsif IsMult( X1 ) then
      if    Equal( X1[ 2 ], X2 ) then
        Swap( [ MULT, X1[ 3 ], [ POW, X2, 2 ] ], R )
      elsif Equal( X1[ 3 ], X2 ) then
        Swap( [ MULT, X1[ 2 ], [ POW, X2, 2 ] ], R ) 
      elsif IsPow( X1[ 2 ] ) and Equal( X1[ 2, 2 ], X2 ) then
        Swap( [ MULT, X1[ 3 ], [ POW, X2, [ PLUS, X1[ 2, 3 ], 1 ] ] ], R )               
      elsif IsPow( X1[ 3 ] ) and Equal( X1[ 3, 2 ], X2 ) then 
        Swap( [ MULT, X1[ 2 ], [ POW, X2, [ PLUS, X1[ 3, 3 ], 1 ] ] ], R )               
      end  
    elsif IsMult( X2 ) then 
      if    Equal( X2[ 2 ], X1 ) then
        Swap( [ MULT, X2[ 3 ], [ POW, X1, 2 ] ], R )
      elsif Equal( X2[ 3 ], X1 ) then
        Swap( [ MULT, X2[ 2 ], [ POW, X1, 2 ] ], R ) 
      elsif IsPow( X2[ 2 ] ) and Equal( X2[ 2, 2 ], X1 ) then 
        Swap( [ MULT, X2[ 3 ], [ POW, X1, [ PLUS, X2[ 2, 3 ], 1 ] ] ], R )               
      elsif IsPow( X2[ 3 ] ) and Equal( X2[ 3, 2 ], X1 ) then 
        Swap( [ MULT, X2[ 2 ], [ POW, X1, [ PLUS, X2[ 3, 3 ], 1 ] ] ], R )               
      end  
    end
  elsif Oper = DIV then 
    X1 == R[ 2 ] 
    X2 == R[ 3 ]
    if IsUnit( X2 ) then
      Swap( X1, R )
    elsif IsZero( X1 ) then
      Swap( X1, R )
    elsif IsPow( X2 ) then  
      Swap( [ MULT, X1, [ POW, X2[ 2 ], [ UN, X2[ 3 ] ] ] ], R )  
    elsif IsZero( X2 ) then
      raise EDivByZero()           
    else
      Swap( [ MULT, X1, [ POW, X2, -1 ] ], R )
    end
  elsif Oper = POW then
    X1 == R[ 2 ] 
    X2 == R[ 3 ]
    if    IsUnit( X2 ) then
      Swap( X1, R )
    elsif IsZero( X2 ) then
      Destroy( R )
      R := 1
    end 
  end 

return R

function CompressFull( Z )
  R := Z
  I := 0
  repeat
    Inc( I )
--    writeln( 'step ' + STR(I) )
    Q := R
    Comp( R )

--    writeln( InOrder( R ) )
  
    eq := Equal( Q, R )
    Destroy( Q )
  until eq
return R

function Diff( A )
  CA := ClassOf( A )
  if    CA = ClassArray then           
    Oper == A[ 1 ]
    K := Card( A )

    X1 == A[ 2 ]
    if Card( A ) >= 3 then
      X2 == A[ 3 ]
    end
    if    Oper = PLUS then
      R := [ PLUS, Diff( X1 ), Diff( X2 ) ]  
    elsif Oper = MINUS then 
      R := [ MINUS, Diff( X1 ), Diff( X2 ) ]  
    elsif Oper = UN then
      R := [ UN, Diff( X1 ) ]
    elsif Oper = MULT then
      R := [ PLUS, [ MULT, Diff( X1 ), X2 ], [ MULT, X1, Diff( X2 ) ] ]     
    elsif Oper = DIV then
      R1 := [ DIV, Diff( X1 ), X2 ] 
      R2 := [ MULT, X1, Diff( X2 ) ]
      R3 := [ MULT, X2, X2 ] 
      R  := [ MINUS, R1, [ DIV, R2, R3 ] ] 
    elsif Oper = LOG then
      R := [ DIV, Diff( X1 ), X1 ]  
    elsif Oper = POW then
      R1 := [ MULT, Diff( X1 ), [ MULT, X2, [ POW, X1, [ MINUS, X2, 1 ] ] ] ]   
      R2 := [ MULT, Diff( X2 ), [ MULT, [ LOG, X1], [ POW, X1, X2 ] ] ]       
      R  := [ PLUS, R1, R2 ]
    else
      raise 0
    end
  elsif IsVar( A ) then
     R := 1
  else
     R := 0
  end
return R

function PlayDiff( A )

  writeln( '---------------------------')
  writeln( 'Symbolic derivation' )
  writeln( '---------------------------' )

  writeln( 'Source :' )
  writeln( A )

  object Scanner( A ) : TScanner
  object Parser( Scanner ) : TParser

  try
    P := Parser.Parse_EXPRESSION()
  except
    on E : TFailrue do
      E.ShowError()
      raise
    end
  end

  writeln( 'Source in Polish notation :' )
  writeln( P )

  writeln( 'Derivation in Polish notation :' )
  Q := Diff( P )
  writeln( Q )

  writeln( 'After compression :' )
  R := CompressFull( Q )
  writeln( R )

  writeln( 'Result :' )
  S := InOrder( R )
  writeln( S )
return S

function PlayComp( A )

  writeln( 'Source :' )
  writeln( A )

  object Scanner( A ) : TScanner 
  object Parser( Scanner ) : TParser

  try
    P := Parser.Parse_EXPRESSION() 
  except
    on E : TFailrue do 
      E.ShowError()  
      raise
    end
  end

  writeln( 'Source in Polish notation :' )    
  writeln( P )

  writeln( 'After compression :' )     
  R := CompressFull( P )  
  writeln( R )

  writeln( 'Result :' )  
  S := InOrder( R )
  writeln( S )
return S

----------- Main program ----------

--PlayComp( '6 - ( X - 1  )' )                     
--return

-- PlayDiff( '1 /  ( X + 1 )' )                                
-- PlayDiff( '1 / ln( X + 1 ) * X' )

-- PlayDiff( '1/(X*X*X*X*X)' )
-- PlayDiff( '1/(X*ln(X+1))' ) 
-- PlayDiff( 'X/ln(X+1)' )
-- PlayDiff( 'X^20/ln(X-1)' ) 
-- PlayDiff( '(X^2-1)/(X+1)' )

PlayDiff( 'X^X' )

return
