--------------------------------------------------------------
--  Subject : Lee algorithm
--  Copyright (c) 1999 by A.Baranovsky
--------------------------------------------------------------

constant
  X = 1 
  Y = 2
  MaxPathLength = 20
end

function Obstructs( P, OBS )
  b := FALSE
  for I:=1 to Card( OBS ) do
    L == OBS[ I, 1 ]
    R == OBS[ I, 2 ]
    b := ( P[X] >= L[X] ) and ( P[X] <= R[X] ) and ( P[Y] >= L[Y] ) and ( P[Y] <= R[Y] )
    if b then
      goto Found
    end
  end
  label Found
return b

function Member( Point, Wave )
  R := FALSE
  P == Wave
  while not Null( P ) do
    if Point = P[ 1 ] then
      R := TRUE
      goto Found
    end
    P == P[ 2 ]
  end
  label Found
return R

function Neighbor( U, V )
  b1 := ( U[X] = V[X] ) and ( Abs( U[Y] - V[Y] ) = 1 )
  b2 := ( U[Y] = V[Y] ) and ( Abs( U[X] - V[X] ) = 1 )
return b1 or b2

function Path( A, B, OBS )
  try
    V := array( MaxPathLength + 1 )       
    V[ 1 ] := [ A, * ]                   
    for K:=1 to MaxPathLength do
      if K > 1 then
        PrevWave == V[ K - 1 ]
      end
      CurrWave == V[ K ]
      NextWave == V[ K + 1 ]
      P == CurrWave
      while not Null( P ) do
        Point := P[ 1 ]
        N := array( 4 )
        N[1] := [ Point[X] + 1, Point[Y] ]
        N[2] := [ Point[X], Point[Y] + 1 ]
        if Point[X] > 0 then
          N[3] := [ Point[X] - 1, Point[Y] ]
        end
        if Point[Y] > 0 then
          N[4] := [ Point[X], Point[Y] - 1 ]
        end
        for I:=1 to 4 do
          NI == N[ I ]
          if not Null( NI ) then
            if NI = B then
              raise Found
            elsif not ( Member( NI, PrevWave ) or Member( NI, CurrWave ) or Member( NI, NextWave ) or Obstructs( NI, OBS ) ) then
              NextWave := [ NI, << NextWave ]
            end
          end
        end
        Destroy( N )
        P == P[ 2 ]
      end
    end
  except
    Result := [ NI, << Result ]
    while K > 0 do
      P == V[ K ]
      while not Null( P ) do
        if Neighbor( P[ 1 ], NI ) then
          NI == P[ 1 ]
          Result := [ NI, << Result ]
          goto Continue
        end
        P == P[ 2 ]
      end
      label Continue
      K := K - 1
    end
  end
return Result

-------- Main program ---------------

N := 3

OBS := array( N )
OBS[ 1 ] := [ [ 2, 3 ], [ 4, 5 ] ]
OBS[ 2 ] := [ [ 6, 6 ], [ 8, 8 ] ]
OBS[ 3 ] := [ [ 4, 7 ], [ 5, 9 ] ]

writeln( '--------------------------------------')
writeln( 'Lee algorithm' )
writeln( '--------------------------------------')

writeln( 'Obstacles :' )

for I:=1 to N do 
  writeln( OBS[I] )
end

PS := [1,1]
writeln( 'Source point : ')
writeln( PS )
PD := [7,9]
writeln( 'Destination point' )
writeln( PD )

Result := Path( PS, PD, OBS )

if Null( Result ) then
  writeln( 'Path not found' )
else
  writeln( 'Path :' )
  writeln( Result )
end

return
