-------------------------------------------------------------- 
--  Subject : Theorem proving ( main program )
--  Compare with Appendix A in "Chang C.L and Lee R.C Symbolic 
--               Logic and Mechanical Theorem Proving", 
--               Academic Press, New York, 1973                            
--  Copyright (c) 1999 by A.Baranovsky
--------------------------------------------------------------

uses chang

  N := 8
  A := array( 50 )

  default ==
  A[ 1 ] := Clause( { |X|   [['+','L',X,['F',X]]                ]})
  A[ 2 ] := Clause( { |X|   [['-','L',X,X]                      ]})
  A[ 3 ] := Clause( { |X,Y| [['-','L',X,Y],['-','L',Y,X]        ]})
  A[ 4 ] := Clause( { |X,Y| [['-','D',X,['F',Y]],['+','L',Y,X]  ]})
  A[ 5 ] := Clause( { |X|   [['+','P',X],['+','D',['H',X],X]    ]})
  A[ 6 ] := Clause( { |X|   [['+','P',X],['+','P',['H',X]]      ]})
  A[ 7 ] := Clause( { |X|   [['+','P',X],['+','L',['H',X],X]    ]})
  A[ 8 ] := Clause( { |X|   [['-','P',X],['-','L','A',X],['+','L',['F','A'],X]  ]})

  W := array( N )
  for I:=3 to N do
    W[ I ] := [ 1, 2 ]
  end

  object &C : Clause

  writeln( 'Source clauses' )

  for I:=1 to N do
    C == A[ I ]
    C.Rename( AX )
    C.Print()
  end

  writeln( '-------------------------------' )
  writeln( 'Theorem proving' )
  writeln( 'Unit binary resolution' )
  writeln( '-------------------------------' )

  writeln( 'Theorem :' )
  writeln( 'The set of prime numbers is unlimited' + EOL() + EOL() );

  TPU( A, W, N, 20 )
return
